package org.dataone.client.audit;

import java.io.InputStream;
import java.util.Date;

import org.dataone.client.D1Node;
import org.dataone.service.exceptions.InsufficientResources;
import org.dataone.service.exceptions.InvalidRequest;
import org.dataone.service.exceptions.InvalidToken;
import org.dataone.service.exceptions.NotAuthorized;
import org.dataone.service.exceptions.NotFound;
import org.dataone.service.exceptions.NotImplemented;
import org.dataone.service.exceptions.ServiceFailure;
import org.dataone.service.types.v1.DescribeResponse;
import org.dataone.service.types.v1.Event;
import org.dataone.service.types.v1.Identifier;
import org.dataone.service.types.v1.Log;
import org.dataone.service.types.v1.ObjectFormatIdentifier;
import org.dataone.service.types.v1.ObjectList;
import org.dataone.service.types.v1.Permission;
import org.dataone.service.types.v1.Session;
import org.dataone.service.types.v1.SystemMetadata;


/**
 * This wrapper overrides the methods in D1Node that would change content on a node
 * being audited, while exposing the other methods.
 * @author rnahf
 *
 */
public class D1NodeAuditingWrapper extends D1Node {
	
	public D1NodeAuditingWrapper(String nodeBaseServiceUrl) {
		super(nodeBaseServiceUrl);
		// TODO Auto-generated constructor stub
	}

	public D1NodeAuditingWrapper(String nodeBaseServiceUrl, Session session) {
		super(nodeBaseServiceUrl, session);
		// TODO Auto-generated constructor stub
	}
	

	/**
	 * override this method to disable potential content changes to the node
	 * Always throws NotImplemented
	 */
	public Identifier generateIdentifier(Session session, String scheme, String fragment) 
	throws NotImplemented 
	{
		throw new NotImplemented("411", "this method is blocked by the auditingWrapper");
	}
	
	
	/**
	 * override this method to disable potential content changes to the node
	 * Always throws NotImplemented
	 */
	public Identifier archive(Session s, Identifier pid) 
	throws NotImplemented 
	{
		throw new NotImplemented("411", "this method is blocked by the auditingWrapper");
	}
	
	
	/**
	 * override this method to disable potential content changes to the node
	 * Always throws NotImplemented
	 */
	public Identifier delete(Session s, Identifier pid) 
	throws NotImplemented 
	{
		throw new NotImplemented("411", "this method is blocked by the auditingWrapper");
	}
}